/* global MembershipInterface */

(function(){

    "use strict";

    var baseUrl = "https://sgv.cstflightservices.com:8444";
    //var baseUrl = "http://localhost:8084";
	

    function showLogOut(user) {
        // hide login button and form
        $(".login-button, .login-content").hide();

        // show user data and logout
        $(".logout-username").html(user.lastName + ", " + user.firstName);
        $(".logout-button, .logout-username").fadeIn();

        // replace online services urls
        if (user.fsc === true) {
            $(".link-fsc").attr("href", baseUrl+"/SGV-Flight_Status").attr("target", "_blank");
        }

        // validate it has at least one API
        if (user.apis.length > 0) {
            $(".link-apis").attr("href", baseUrl+"/APIS").attr("target", "_blank");
        }
    }

    // add the response listener
    window.addEventListener('message', function(event) {

        // log the response
        var data = event.data.data;
        switch (event.data.method) {

            case "getUser":
                // if user is null, there's no current session
                if (data.user === null) {
                    // desktop
                    $("input.login-button")
                        .val("ONLINE SERVICES LOGIN")
                        .removeAttr("disabled");

                    // mobile
                    $("a.login-button")
                        .html("ONLINE SERVICES LOGIN")
                        .removeAttr("disabled")
                        .attr("href", "Login.html");
                    return;
                }

                // user must complete their security questions before continue
                if (data.user.question1 === null) {
                    window.location = "Security-Questions.html";
                    return;
                }

                showLogOut(data.user);
                break;

            case "logOut":
                location.reload();
                break;
        }
    });

    $(function() {

        $('#ms-frame').on('load', function() {
            MembershipInterface.getUser('ms-frame');
        });

        $(".logout-button").click(function() {
            MembershipInterface.logOut('ms-frame');
            return false;
        });

    });

})();
